clear variables
close all
clc

% Učitavanje podataka o mreži

load('IEEE 34 Node Test Feeder.mat') ;
Zl = R + sqrt(-1)*X ;
S = - P_load - sqrt(-1)*Q_load ;

% Inicijalizacija

V = ones(Number_of_Buses,1) ;
V_old = zeros(size(V)) ;
Tolerance = 1e-3 ;
I = zeros(Number_of_Buses,1) ;
Jl = zeros(Number_of_Branches,1) ;
Y = zeros(Number_of_Buses,1) ;
Iteration = 0 ;

while max(abs(V_old-V)) > Tolerance
    
    Iteration = Iteration + 1 ;
    V_old = V ;
    
    % Proračun injektiranih struja u čvorovima sistema
    
    for i = 1 : Number_of_Buses
        
        I(i) = conj(S(i)/V(i)) - Y(i)*V(i) ;
        
    end
    
    % Proračun struja po granama mreže
    
    for i = Number_of_Branches : -1 : 1
        
        Jl(i) = - I(To_Bus(i)) ;
        
        for j = i + 1 : Number_of_Branches
            
            if From_Bus(j) == To_Bus(i)
                
                Jl(i) = Jl(i) + Jl(j) ;
                
            end
            
        end
        
    end
    
    % Proračun napona u čvorovima sistema
    
    for i = 1 : Number_of_Branches
        
        V(To_Bus(i)) = V(From_Bus(i)) - Zl(i)*Jl(i) ;
        
    end
        
end

figure
plot(abs(V),'LineWidth',1.5)
xlabel('Bus')
ylabel('Voltage [p.u.]')
grid on 
box on